/*
 * wrapper.c:
 *
 * Copyright (c) 2000 James McKenzie <james@fishsoup.dhs.org>.
 * All rights reserved.
 *
 *  By using this file, you agree to the terms and conditions set
 *  forth in the LICENCE file which can be found at the top level directory.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: wrapper.c,v $
 * Revision 1.3  2000/02/17 15:35:18  root
 * #
 *
 * Revision 1.2  2000/02/17 15:28:55  root
 * #
 *
 *
 */

static char rcsid[] = "$Id: wrapper.c,v 1.3 2000/02/17 15:35:18 root Exp root $";

#include<stdio.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<stdarg.h>

#include "gphoto.h"

char *serial_port = "/dev/ttyS0";

extern struct _Camera samsung800k;

#define MAX_PHOTOS 1024

int sizes[MAX_PHOTOS];

int
main (int argc, char **argv)
{
  int n;
  int i;

  if (argc == 2)
    {
      serial_port = argv[1];
    }

  if (samsung800k.initialize ())
    {
      exit (1);
    }

  n = SDSC_QueryPicsEx (sizes);

  printf ("Camera has %d pictures\n", n);

  for (i = 1; i <= n; ++i)
    {
      struct Image *img;
      char name[1024];
      FILE *f;
      int fl;

      snprintf (name, sizeof (name), "img-%03d.jpg", i);

      f = fopen (name, "r");
      fl = 0;

      if (f)
        {
          fseek (f, 0L, SEEK_END);
          fl = (int) ftell (f);
          fclose (f);
        }

      if ((fl) && (fl != sizes[i - 1]))
        {
          printf ("Not overwriting %s\n", name);
        }
      else if (fl == sizes[i - 1])
        {
          printf ("Already got %s\n", name);
        }
      else
        {
          printf ("Reading %s (%d/%d %d bytes) ...", name, i, n, sizes[i - 1]);
          fflush (stdout);

          img = samsung800k.get_picture (i, 0);
          if (!img)
            {
              printf ("Failed\n");

            }
          else
            {
              printf ("Done\n", img->image_size);

              f = fopen (name, "w");
              fwrite (img->image, 1, img->image_size, f);
              fclose (f);

              free (img->image);
              free (img);
            }

        }



    }










}
